<?php if (!defined('ABSPATH')) {exit;}
/**
 * Plugin Updates
 *
 * @link			https://icopydoc.ru/
 * @since		1.6.0
 */

class IPYTW_Data_Arr {
	private $data_arr = [
		['ipytw_status_cron', 'off', 'private'],
		['ipytw_date_sborki', '0000000001', 'private'], // дата начала сборки
		['ipytw_date_sborki_end', '0000000001', 'private'], // дата завершения сборки
		['ipytw_date_save_set', '0000000001', 'private'], // дата сохранения настроек плагина
		['ipytw_count_elements', -1, 'public'],
		['ipytw_run_cron', 'off', 'public'],
		['ipytw_feed_assignment', '', 'public'],
		['ipytw_url_yml_file', '', 'public'],
		['ipytw_feed_login', '', 'public'],
		['ipytw_feed_pwd', '', 'public'],
		['ipytw_dir_copy_feed_from_source', '', 'public'],
		['ipytw_when_import_category', 'always', 'public'],
		['ipytw_product_was_sync', 'price_only', 'public'],
		['ipytw_post_status', 'publish', 'public'],
		['ipytw_step_import', 25, 'public'],
		['ipytw_whot_import', 'simple', 'public'],
		['ipytw_behaviour_one_variation', 'skip', 'public'],
		['ipytw_external', 'disabled', 'public'],
		['ipytw_partner_link', '', 'public'],
		['ipytw_description_into', 'full', 'public'],
		['ipytw_source_sku', 'disabled', 'public'],
		['ipytw_add_pref_to_sku', '', 'public'],
		['ipytw_params_separator', '', 'public'],
		['ipytw_find_sale_price', 'enabled', 'public'],
		['ipytw_if_isset_sku', 'update', 'public'],
		['ipytw_missing_product', 'disabled', 'public'],
		['ipytw_list_import_err_code_arr', [ ], 'public'],
		['ipytw_fsize_limit', 5, 'public'],
		['ipytw_count_offers', 0, 'public']
	];

	public function __construct($data_arr = [ ]) {
		if (!empty($data_arr)) {
			$this->data_arr = $data_arr;
		}		
		$this->data_arr = apply_filters('ipytw_set_default_feed_settings_result_arr_filter', $this->data_arr);
	}

	public function get_data_arr() {
		return $this->data_arr;
	}

	// @return array([0] => opt_key1, [1] => opt_key2, ...)
	public function get_opts_name($whot = '') {
		if ($this->data_arr) {
			$res_arr = [ ];		
			for ($i = 0; $i < count($this->data_arr); $i++) {
				switch ($whot) {
					case "public":
						if ($this->data_arr[$i][2] === 'public') {
							$res_arr[] = $this->data_arr[$i][0];
						}
					break;
					case "private":
						if ($this->data_arr[$i][2] === 'private') {
							$res_arr[] = $this->data_arr[$i][0];
						}
					break;
					default:
						$res_arr[] = $this->data_arr[$i][0];
				}
			}
			return $res_arr;
		} else {
			return [ ];
		}
	}

	// @return array(opt_name1 => opt_val1, opt_name2 => opt_val2, ...)
	public function get_opts_name_and_def_date($whot = 'all') {
		if ($this->data_arr) {
			$res_arr = [ ];		
			for ($i = 0; $i < count($this->data_arr); $i++) {
				switch ($whot) {
					case "public":
						if ($this->data_arr[$i][2] === 'public') {
							$res_arr[$this->data_arr[$i][0]] = $this->data_arr[$i][1];
						}
					break;
					case "private":
						if ($this->data_arr[$i][2] === 'private') {
							$res_arr[$this->data_arr[$i][0]] = $this->data_arr[$i][1];
						}
					break;
					default:
						$res_arr[$this->data_arr[$i][0]] = $this->data_arr[$i][1];
				}
			}
			return $res_arr;
		} else {
			return [ ];
		}
	}

	public function get_opts_name_and_def_date_obj($whot = 'all') {		
		$source_arr = $this->get_opts_name_and_def_date($whot);

		$res_arr = [ ];	
		foreach($source_arr as $key => $value) {
			$res_arr[] = new IPYTW_Data_Arr_Helper($key, $value); // return unit obj
		}
		return $res_arr;
	}
}
class IPYTW_Data_Arr_Helper {	
	private $opt_name;
	private $opt_def_value;

	function __construct($name = '', $def_value = '') {
		$this->opt_name = $name;
		$this->opt_def_value = $def_value;
	}

	function get_name() {
		return $this->opt_name;
	}

	function get_value() {
		return $this->opt_def_value;
	}
}