<?php if (!defined('ABSPATH')) {exit;}
/**
 * Plugin Settings Page
 *
 * @package			Import from YML
 * @subpackage		
 * @since			1.7.0
 * 
 * @version			1.0.0
 * @author			Maxim Glazunov
 * @link			https://icopydoc.ru/
 * @see				
 * 
 * @param		
 *
 * @return		
 *
 * @depends			classes:	IPYTW_Feedback
 *								EOPN_WP_List_Table
 *								IPYTW_Data_Arr
 *								IPYTW_Error_Log
 *					traits:	
 *					methods:	
 *					functions:	ipytw_optionGET
 *					constants:	IPYTW_PLUGIN_DIR_URL
 *					options:	
 *
 */

class IPYTW_Settings_Page {
	private $feed_id;
	private $feedback;

	public function __construct() {
		$this->feedback = new IPYTW_Feedback();

		$this->init_hooks(); // подключим хуки
		$this->listen_submit();

		$this->get_html_form();	
	}

	public function get_html_form() { ?>
		<div class="wrap">
  			<h1><?php _e('Import products from YML to WooCommerce', 'import-from-yml'); ?></h1>
			<div id="poststuff">
				<?php $this->get_html_feeds_list(); ?>

				<div id="post-body" class="columns-2">

					<div id="postbox-container-1" class="postbox-container">
						<div class="meta-box-sortables">							
							<?php do_action('ipytw_before_support_project'); ?>
							<?php $this->feedback->get_block_support_project(); ?>
							<?php do_action('ipytw_between_container_1', $this->get_feed_id()); ?>
							<?php $this->feedback->get_form(); ?>
							<?php do_action('ipytw_append_container_1', $this->get_feed_id()); ?>
						</div>
					</div><!-- /postbox-container-1 -->

					<div id="postbox-container-2" class="postbox-container">
						<div class="meta-box-sortables">
							<?php if (empty($this->get_feed_id())) : ?>
								<?php _e('YML feeds not found', 'import-from-yml'); ?>. <?php _e('Click the "Add New Feed" button at the top of this page', 'import-from-yml'); ?>.
							<?php else: 
								if (isset($_GET['tab'])) {$tab = $_GET['tab'];} else {$tab = 'main_tab';}
								echo $this->get_html_tabs($tab); ?>

								<form action="<?php echo esc_url($_SERVER['REQUEST_URI']); ?>" method="post" enctype="multipart/form-data">
									<?php do_action('ipytw_prepend_form_container_2', $this->get_feed_id()); ?>
									<input type="hidden" name="ipytw_num_feed_for_save" value="<?php echo $this->get_feed_id(); ?>">
									<?php switch ($tab) : 
										case 'main_tab' : ?>
											<?php $this->get_html_main_settings(); ?>
											<?php break; ?>
									<?php break; ?>
									<?php endswitch; ?>

									<?php do_action('ipytw_after_optional_elemet_block', $this->get_feed_id()); ?>
									<div class="postbox">
										<div class="inside">
											<table class="form-table"><tbody>
												<tr>
													<th scope="row"><label for="button-primary"></label></th>
													<td class="overalldesc"><?php wp_nonce_field('ipytw_nonce_action', 'ipytw_nonce_field'); ?><input id="button-primary" class="button-primary" type="submit" name="ipytw_submit_action" value="<?php 
													if ($tab === 'main_tab') {
														echo __('Save', 'import-from-yml').' & '. __('Run import', 'import-from-yml'); 
													} else {
														_e('Save', 'import-from-yml');
													}
													?>"/><br />
													<span class="description"><small><?php _e('Click to save the settings', 'import-from-yml'); ?><small></span></td>
												</tr>
											</tbody></table>
										</div>
									</div>
								</form>
							<?php endif; ?>
						</div>
					</div><!-- /postbox-container-2 -->

				</div>
			</div><!-- /poststuff -->
			<?php $this->get_html_icp_banners(); ?>
			<?php $this->get_html_my_plugins_list(); ?>
		</div><?php // end get_html_form();
	}

	public function get_html_feeds_list() { 
		$ipytwListTable = new EOPN_WP_List_Table(); ?>
		<form action="<?php echo esc_url($_SERVER['REQUEST_URI']); ?>" method="post" enctype="multipart/form-data">
			<?php wp_nonce_field('ipytw_nonce_action_add_new_feed', 'ipytw_nonce_field_add_new_feed'); ?><input class="button" type="submit" name="ipytw_submit_add_new_feed" value="<?php _e('Add New Feed', 'import-from-yml'); ?>" />
		</form>
		<form method="get">
			<input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>"/>
			<input type="hidden" name="ipytw_form_id" value="ipytw_wp_list_table" />
			<?php $ipytwListTable->prepare_items(); $ipytwListTable->display(); ?>
		</form><?php // end get_html_feeds_list();
	} // end get_html_feeds_list();

	public function get_html_tabs($current = 'main_tab') {
		$tabs = array(
			'main_tab' 		=> __('Main settings', 'import-from-yml')
		);
		
		$html = '<div class="nav-tab-wrapper" style="margin-bottom: 10px;">';
			foreach ($tabs as $tab => $name) {
				if ($tab === $current) {
					$class = ' nav-tab-active';
				} else {
					$class = ''; 
				}
				if (isset($_GET['feed_id'])) {
					$nf = '&feed_id='.sanitize_text_field($_GET['feed_id']);
				} else {
					$nf = '';
				}
				$html .= sprintf('<a class="nav-tab%1$s" href="?page=ipytwexport&tab=%2$s%3$s">%4$s</a>',$class, $tab, $nf, $name);
			}
		$html .= '</div>';

		return $html;
	} // end get_html_tabs();

	public function get_html_main_settings() {		
		$ipytw_status_cron = ipytw_optionGET('ipytw_status_cron', $this->get_feed_id(), 'set_arr');
		$ipytw_feed_assignment = ipytw_optionGET('ipytw_feed_assignment', $this->get_feed_id(), 'set_arr');
		$ipytw_url_yml_file = ipytw_optionGET('ipytw_url_yml_file', $this->get_feed_id(), 'set_arr');
		$ipytw_feed_login = ipytw_optionGET('ipytw_feed_login', $this->get_feed_id(), 'set_arr');
		$ipytw_feed_pwd = ipytw_optionGET('ipytw_feed_pwd', $this->get_feed_id(), 'set_arr');
		$ipytw_when_import_category = ipytw_optionGET('ipytw_when_import_category', $this->get_feed_id(), 'set_arr');
		$ipytw_product_was_sync = ipytw_optionGET('ipytw_product_was_sync', $this->get_feed_id(), 'set_arr');
		$ipytw_post_status = ipytw_optionGET('ipytw_post_status', $this->get_feed_id(), 'set_arr');
		$ipytw_step_import = ipytw_optionGET('ipytw_step_import', $this->get_feed_id(), 'set_arr');
		$ipytw_whot_import = ipytw_optionGET('ipytw_whot_import', $this->get_feed_id(), 'set_arr');
		$ipytw_behaviour_one_variation = ipytw_optionGET('ipytw_behaviour_one_variation', $this->get_feed_id(), 'set_arr');
		$ipytw_external = ipytw_optionGET('ipytw_external', $this->get_feed_id(), 'set_arr');
		$ipytw_partner_link = ipytw_optionGET('ipytw_partner_link', $this->get_feed_id(), 'set_arr');
		$ipytw_description_into = ipytw_optionGET('ipytw_description_into', $this->get_feed_id(), 'set_arr');
		$ipytw_source_sku = ipytw_optionGET('ipytw_source_sku', $this->get_feed_id(), 'set_arr');
		$ipytw_add_pref_to_sku = ipytw_optionGET('ipytw_add_pref_to_sku', $this->get_feed_id(), 'set_arr');
		$ipytw_params_separator = ipytw_optionGET('ipytw_params_separator', $this->get_feed_id(), 'set_arr');
		$ipytw_find_sale_price = ipytw_optionGET('ipytw_find_sale_price', $this->get_feed_id(), 'set_arr');
		$ipytw_if_isset_sku = ipytw_optionGET('ipytw_if_isset_sku', $this->get_feed_id(), 'set_arr');
		$ipytw_missing_product = ipytw_optionGET('ipytw_missing_product', $this->get_feed_id(), 'set_arr');
		$ipytw_fsize_limit = ipytw_optionGET('ipytw_fsize_limit', $this->get_feed_id(), 'set_arr');
		?>
		<div class="postbox">
			<h2 class="hndle">
				<?php _e('Main parameters', 'import-from-yml'); ?> (<?php _e('Feed', 'import-from-yml'); ?> ID: <?php echo $this->get_feed_id(); ?>)
				<br/><span class="delete"><?php printf('(<a style="color: #b32d2e;" href="?page=%s&action=%s&feed_id=%s">%s</a>)', $_REQUEST['page'], 'delete', $this->get_feed_id(), __('delete', 'import-from-yml')); ?></span>
			</h2>
			<div class="inside">
				<table class="form-table"><tbody>
					<tr class="ipytw_tr">
						<th scope="row"><label for="ipytw_run_cron"><?php _e('Start automatic import', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_run_cron" id="ipytw_run_cron">
								<option value="off" <?php selected($ipytw_status_cron, 'off' ); ?>><?php _e("Don't start", "import-from-yml"); ?></option>
								<?php $ipytw_enable_five_min = ipytw_optionGET('ipytw_enable_five_min'); if ($ipytw_enable_five_min === 'on') : ?>
								<option value="five_min" <?php selected($ipytw_status_cron, 'five_min');?> ><?php _e('Every five minutes', 'import-from-yml'); ?></option>
								<?php endif; ?>
								<option value="hourly" <?php selected($ipytw_status_cron, 'hourly');?> ><?php _e('Hourly', 'import-from-yml'); ?></option>
								<option value="six_hours" <?php selected($ipytw_status_cron, 'six_hours'); ?> ><?php _e('Every six hours', 'import-from-yml'); ?></option>	
								<option value="twicedaily" <?php selected($ipytw_status_cron, 'twicedaily');?> ><?php _e('Twice a day', 'import-from-yml'); ?></option>
								<option value="daily" <?php selected($ipytw_status_cron, 'daily');?> ><?php _e('Daily', 'import-from-yml'); ?></option>
								<option value="every_two_days" <?php selected($ipytw_status_cron, 'every_two_days');?> ><?php _e('Every two days', 'import-from-yml'); ?></option>
								<option value="week" <?php selected($ipytw_status_cron, 'week');?> ><?php _e('Once a week', 'import-from-yml'); ?></option>
							</select><br />
							<span class="description"><small><?php _e('Products import interval from feed', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_feed_assignment"><?php _e('Feed assignment', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input type="text" maxlength="20" name="ipytw_feed_assignment" id="ipytw_feed_assignment" value="<?php echo $ipytw_feed_assignment; ?>" placeholder="<?php _e('For Yandex Market', 'import-from-yml');?>" /><br />
							<span class="description"><small><?php _e("Doesn't affect imports. Inner note for your convenience", "import-from-yml"); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_url_yml_file"><?php _e('YML File', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input <?php if ($ipytw_url_yml_file !== '') {echo 'readonly';} ?> type="text" name="ipytw_url_yml_file" id="ipytw_url_yml_file" value="<?php echo $ipytw_url_yml_file; ?>" placeholder="https://site.ru/feed.yml" /><br />
							<small><?php _e('Specify URL to the YML feed in the field above or upload the file from your computer using the button below', 'import-from-yml'); ?></small><br />
							<input type="file" name="ipytw_image_upload" id="ipytw_image_upload" multiple="false" accept=".xml,.yml"/>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_feed_login"><?php _e('Login', 'import-from-yml'); ?> <?php _e('to access the feed', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input type="text" name="ipytw_feed_login" id="ipytw_feed_login" value="<?php echo $ipytw_feed_login; ?>" /><br />
							<span class="description"><small><?php _e("Don't fill in if the feed is freely available", "import-from-yml"); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_feed_pwd"><?php _e('Password', 'import-from-yml'); ?> <?php _e('to access the feed', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input type="text" name="ipytw_feed_pwd" id="ipytw_feed_pwd" value="<?php echo $ipytw_feed_pwd; ?>" /><br />
							<span class="description"><small><?php _e("Don't fill in if the feed is freely available", "import-from-yml"); ?></small></span>
						</td>
					</tr>
					<tr class="ipytw_tr">
						<th scope="row"><label for="ipytw_when_import_category"><?php _e('When to import categories', 'import-from-yml'); ?>?</label></th>
						<td class="overalldesc">
							<select name="ipytw_when_import_category" id="ipytw_when_import_category">			
							<option value="always" <?php selected($ipytw_when_import_category, 'always'); ?>><?php _e('Always', 'import-from-yml'); ?></option>
							<option value="once" <?php selected($ipytw_when_import_category, 'once'); ?>><?php _e('Import once', 'import-from-yml'); ?></option>
							<option value="disabled" <?php selected($ipytw_when_import_category, 'disabled'); ?>><?php _e('Never', 'import-from-yml'); ?></option>
							<?php do_action('ipytw_when_import_category_option', $this->get_feed_id(), $ipytw_when_import_category); ?>
							</select>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_product_was_sync"><?php _e('If the product was previously synced', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_product_was_sync" id="ipytw_product_was_sync">
							<option value="whole" <?php selected($ipytw_product_was_sync, 'whole'); ?>><?php _e('Update whole', 'import-from-yml'); ?></option>
							<option value="whole_except_cat" <?php selected($ipytw_product_was_sync, 'whole_except_cat'); ?>><?php _e('Update whole except categories', 'import-from-yml'); ?></option>							
							<option value="price_only" <?php selected($ipytw_product_was_sync, 'price_only'); ?>><?php _e('Update price only', 'import-from-yml'); ?></option>
							<option value="stock_only" <?php selected($ipytw_product_was_sync, 'stock_only'); ?>><?php _e('Update stock only', 'import-from-yml'); ?></option>
							<option value="price_and_stock" <?php selected($ipytw_product_was_sync, 'price_and_stock'); ?>><?php _e('Update price and stock only', 'import-from-yml'); ?></option>
							<option value="dont_update" <?php selected($ipytw_product_was_sync, 'dont_update'); ?>><?php _e("Don't update this product", "import-from-yml"); ?></option>				
							<?php do_action('ipytw_product_was_sync_option', $this->get_feed_id(), $ipytw_product_was_sync); ?>
							</select>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_post_status"><?php _e('Set post status after import products', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_post_status" id="ipytw_post_status">
							<option value="publish" <?php selected($ipytw_post_status, 'publish'); ?>><?php _e('Publish', 'import-from-yml'); ?></option>
							<option value="draft" <?php selected($ipytw_post_status, 'draft'); ?>><?php _e('Draft', 'import-from-yml'); ?></option>
							<option value="pending" <?php selected($ipytw_post_status, 'pending'); ?>><?php _e('Pending', 'import-from-yml'); ?></option>
							</select><br />
							<span class="description"><small><?php _e('Default', 'import-from-yml'); ?>: <?php _e('Publish', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr class="ipytw_tr">
						<th scope="row"><label for="ipytw_step_import"><?php _e('Step of import', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_step_import" id="ipytw_step_import">
							<option value="10" <?php selected($ipytw_step_import, 10); ?>>10 <?php _e('sec', 'import-from-yml'); ?></option>
							<option value="15" <?php selected($ipytw_step_import, 15); ?>>15 <?php _e('sec', 'import-from-yml'); ?></option>
							<option value="20" <?php selected($ipytw_step_import, 20); ?>>20 <?php _e('sec', 'import-from-yml'); ?></option>
							<option value="25" <?php selected($ipytw_step_import, 25); ?>>25 <?php _e('sec', 'import-from-yml'); ?></option>
							<option value="30" <?php selected($ipytw_step_import, 30); ?>>30 <?php _e('sec', 'import-from-yml'); ?></option>
							<?php do_action('ipytw_step_import_option', $this->get_feed_id(), $ipytw_step_import); ?>
							</select><br />
							<span class="description"><small><?php _e('The value affects the speed of import', 'import-from-yml'); ?>. <?php _e('If you are having trouble importing, try reduce the value in this field', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_whot_import"><?php _e('Whot import', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_whot_import" id="ipytw_whot_import">
								<option value="simple" <?php selected($ipytw_whot_import, 'simple'); ?>><?php _e('Only simple products', 'import-from-yml'); ?></option>
								<option value="all" <?php selected($ipytw_whot_import, 'all'); ?>><?php _e('Simple & Variable products', 'import-from-yml'); ?> (beta)*</option>
								<?php do_action('ipytw_whot_import_option', $this->get_feed_id(), $ipytw_whot_import); ?>
							</select><br />
							<span class="description"><small>* <?php _e('Important. The feature is under testing. Use it with care', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_behaviour_one_variation"><?php _e('If only one variation', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_behaviour_one_variation" id="ipytw_behaviour_one_variation">
								<option value="skip" <?php selected($ipytw_behaviour_one_variation, 'skip'); ?>><?php _e('Skip', 'import-from-yml'); ?></option>
								<option value="add_as_simple" <?php selected($ipytw_behaviour_one_variation, 'add_as_simple'); ?>><?php _e('Add as simple product', 'import-from-yml'); ?> (beta)*</option>
								<?php do_action('ipytw_behaviour_one_variation_option', $this->get_feed_id(), $ipytw_behaviour_one_variation); ?>
							</select><br />
							<span class="description"><small>* <?php _e('Important. The feature is under testing. Use it with care', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr class="ipytw_tr">
						<th scope="row"><label for="ipytw_external"><?php _e('Import all products as external', 'import-from-yml'); ?> (beta)*</label></th>
						<td class="overalldesc">
							<select name="ipytw_external" id="ipytw_external">
								<option value="disabled" <?php selected($ipytw_external, 'disabled'); ?>><?php _e('Disabled', 'import-from-yml'); ?></option>
								<option value="enabled" <?php selected($ipytw_external, 'enabled'); ?>><?php _e('Enabled', 'import-from-yml'); ?></option>
							</select><br />
							<span class="description"><small>* <?php _e('Important. The feature is under testing. Only simple products from YML will be imported as external products', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_partner_link"><?php _e('Partner link', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input type="text" name="ipytw_partner_link" id="ipytw_partner_link" value="<?php echo $ipytw_partner_link; ?>" placeholder="?partner=12345" /><br />
							<span class="description"><small><?php _e('This setting works only if', 'import-from-yml'); ?> "<strong><?php _e('Import all products as external', 'import-from-yml'); ?></strong>" <?php _e('is selected in the', 'import-from-yml'); ?> "<strong><?php _e('Enabled', 'import-from-yml'); ?></strong>"</small></span>
						</td>
					</tr>
					<tr class="ipytw_tr">
						<th scope="row"><label for="ipytw_description_into"><?php _e('Description of products to import into', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_description_into" id="ipytw_description_into">						
								<option value="full" <?php selected($ipytw_description_into, 'full'); ?>><?php _e('Full description', 'import-from-yml'); ?></option>
								<option value="excerpt" <?php selected($ipytw_description_into, 'excerpt'); ?>><?php _e('Short description', 'import-from-yml'); ?></option>
							</select>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_source_sku"><?php _e('SKU', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_source_sku" id="ipytw_source_sku">
							<option value="disabled" <?php selected($ipytw_source_sku, 'disabled'); ?>><?php _e("Don't import", "import-from-yml"); ?></option>
							<option value="vendor_code" <?php selected($ipytw_source_sku, 'vendor_code'); ?>>vendorCode</option>
							<option value="shop_sku" <?php selected($ipytw_source_sku, 'shop_sku'); ?>>shop-sku</option>
							<option value="sku" <?php selected($ipytw_source_sku, 'sku'); ?>>sku</option>
							<option value="article" <?php selected($ipytw_source_sku, 'article'); ?>>article</option>
							<option value="product_id" <?php selected($ipytw_source_sku, 'product_id'); ?>><?php _e('Product ID', 'import-from-yml'); ?></option>
							<?php do_action('ipytw_source_sku_option', $this->get_feed_id(), $ipytw_source_sku); ?>
							</select><br />
							<span class="description"><small><?php _e('Select the feed element, which contains the SKU', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_add_pref_to_sku"><?php _e('Add a prefix to', 'import-from-yml'); ?> <?php _e('SKU', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input type="text" name="ipytw_add_pref_to_sku" id="ipytw_add_pref_to_sku" value="<?php echo $ipytw_add_pref_to_sku; ?>" placeholder="sp1_" /><br />
							<span class="description"><small><?php _e('Add a prefix to', 'import-from-yml'); ?> <?php _e('SKU', 'import-from-yml'); ?></strong></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_params_separator"><?php _e('Value separator for', 'import-from-yml'); ?> param</label></th>
						<td class="overalldesc">
							<input type="text" name="ipytw_params_separator" id="ipytw_params_separator" value="<?php echo $ipytw_params_separator; ?>" placeholder="#$" /><br />
							<span class="description"><small><?php _e('If there can be several values in one "param" element at once, specify the separator', 'import-from-yml'); ?></strong></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_find_sale_price"><?php _e('Sale price', 'import-from-yml'); ?> (oldprice)</label></th>
						<td class="overalldesc">
							<select name="ipytw_find_sale_price" id="ipytw_find_sale_price">
							<option value="enabled" <?php selected($ipytw_find_sale_price, 'enabled'); ?>><?php _e('Import', 'import-from-yml'); ?></option>
							<option value="disabled" <?php selected($ipytw_find_sale_price, 'disabled'); ?>><?php _e("Don't import", "import-from-yml"); ?></option>
							<?php do_action('ipytw_find_sale_price_option', $this->get_feed_id(), $ipytw_find_sale_price); ?>
							</select>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_if_isset_sku"><?php _e('If there is a product on the site with the same SKU', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<select name="ipytw_if_isset_sku" id="ipytw_if_isset_sku">
							<option value="disabled" <?php selected($ipytw_if_isset_sku, 'disabled'); ?>><?php _e("Don't import", "import-from-yml"); ?></option>				
							<option value="without_sku" <?php selected($ipytw_if_isset_sku, 'without_sku'); ?>><?php _e('Import without SKU', 'import-from-yml'); ?></option>
							<option value="update" <?php selected($ipytw_if_isset_sku, 'update'); ?>><?php _e('Replace product on your site', 'import-from-yml'); ?></option>
							<?php do_action('ipytw_if_isset_sku_option', $this->get_feed_id(), $ipytw_if_isset_sku); ?>
							</select><br />
							<span class="description"><small><?php _e('Choose what to do if, when importing products, an product with the same SKU as in the feed is found on your website', 'import-from-yml'); ?></small></span>
						</td>
					</tr>
					<tr>
						<th scope="row"><label for="ipytw_missing_product"><?php _e('If the product is not in the feed', 'import-from-yml'); ?></label><br /><small><i>(<?php _e('Important. The feature is under testing. Use it with care', 'import-from-yml'); ?></i>!)</small></th>
						<td class="overalldesc">
							<select name="ipytw_missing_product" id="ipytw_missing_product">
							<option value="disabled" <?php selected($ipytw_missing_product, 'disabled'); ?>><?php _e('Nothing', 'import-from-yml'); ?></option>				
							<option value="del" <?php selected($ipytw_missing_product, 'del'); ?>><?php _e('Delete the product, but do not delete its attachments', 'import-from-yml'); ?></option>
							<option value="del_with_pic" <?php selected($ipytw_missing_product, 'del_with_pic'); ?>><?php _e('Delete the product and its attachments', 'import-from-yml'); ?> **</option>
							<option value="out_of_stock" <?php selected($ipytw_missing_product, 'out_of_stock'); ?>><?php _e('Set the status', 'import-from-yml'); ?> "<?php _e('Not in stock', 'import-from-yml'); ?>"</option>
							<?php do_action('ipytw_missing_product_option', $this->get_feed_id(), $ipytw_missing_product); ?>
							</select><br />
							<span class="description"><small><?php _e('What if a previously imported product is missing from the feed', 'import-from-yml'); ?><br />
							<strong>** <?php _e('Important', 'import-from-yml'); ?>!</strong> <?php _e('The function is under testing and may cause the server to freeze', 'import-from-yml'); ?>
							</small></span>
						</td>
					</tr>
					<tr class="ipytw_tr">
						<th scope="row"><label for="ipytw_fsize_limit"><?php _e('Skip images larger than', 'import-from-yml'); ?></label></th>
						<td class="overalldesc">
							<input type="number" step="1" min="1" max="20" name="ipytw_fsize_limit" id="ipytw_fsize_limit" value="<?php echo $ipytw_fsize_limit; ?>" placeholder="5" /><br />
							<span class="description"><small><?php _e('Skip images larger than', 'import-from-yml'); ?> (MB) <strong><i>(<?php _e("Default", "import-from-yml"); ?>: 5)</i><strong></small></span>
						</td>
					</tr>
				</tbody></table>
			</div>
		</div>
		<?php do_action('ipytw_before_button_primary_submit', $this->get_feed_id()); ?>		
		<?php
	} // end get_html_main_settings();

	public function get_html_icp_banners() { ?>
		<div id="icp_slides" class="clear">
			<div class="icp_wrap">
				<input type="radio" name="icp_slides" id="icp_point1">
				<input type="radio" name="icp_slides" id="icp_point2">
				<input type="radio" name="icp_slides" id="icp_point3" checked>
				<input type="radio" name="icp_slides" id="icp_point4">
				<input type="radio" name="icp_slides" id="icp_point5">
				<input type="radio" name="icp_slides" id="icp_point6">
				<input type="radio" name="icp_slides" id="icp_point7">
				<div class="icp_slider">
					<div class="icp_slides icp_img1"><a href="//wordpress.org/plugins/yml-for-yandex-market/" target="_blank"></a></div>
					<div class="icp_slides icp_img2"><a href="//wordpress.org/plugins/import-products-to-ok-ru/" target="_blank"></a></div>
					<div class="icp_slides icp_img3"><a href="//wordpress.org/plugins/xml-for-google-merchant-center/" target="_blank"></a></div>
					<div class="icp_slides icp_img4"><a href="//wordpress.org/plugins/gift-upon-purchase-for-woocommerce/" target="_blank"></a></div>
					<div class="icp_slides icp_img5"><a href="//wordpress.org/plugins/xml-for-avito/" target="_blank"></a></div>
					<div class="icp_slides icp_img6"><a href="//wordpress.org/plugins/xml-for-o-yandex/" target="_blank"></a></div>
					<div class="icp_slides icp_img7"><a href="//wordpress.org/plugins/import-from-yml/" target="_blank"></a></div>
				</div>
				<div class="icp_control">
					<label for="icp_point1"></label>
					<label for="icp_point2"></label>
					<label for="icp_point3"></label>
					<label for="icp_point4"></label>
					<label for="icp_point5"></label>
					<label for="icp_point6"></label>
					<label for="icp_point7"></label>
				</div>
			</div> 
		</div><?php 
	} // end get_html_icp_banners()

	public function get_html_my_plugins_list() { ?>
		<div class="metabox-holder">
			<div class="postbox">
				<h2 class="hndle"><?php _e('My plugins that may interest you', 'import-from-yml'); ?></h2>
				<div class="inside">
					<p><span class="ipytw_bold">XML for Google Merchant Center</span> - <?php _e('Сreates a XML-feed to upload to Google Merchant Center', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/xml-for-google-merchant-center/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p> 
					<p><span class="ipytw_bold">YML for Yandex Market</span> - <?php _e('Сreates a YML-feed for importing your products to Yandex Market', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/yml-for-yandex-market/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">Import from YML</span> - <?php _e('Imports products from YML to your shop', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/import-from-yml/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">Integrate myTarget for WooCommerce</span> - <?php _e('This plugin helps setting up myTarget counter for dynamic remarketing for WooCommerce', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/wc-mytarget/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">XML for Hotline</span> - <?php _e('Сreates a XML-feed for importing your products to Hotline', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/xml-for-hotline/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">Gift upon purchase for WooCommerce</span> - <?php _e('This plugin will add a marketing tool that will allow you to give gifts to the buyer upon purchase', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/gift-upon-purchase-for-woocommerce/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">Import products to ok.ru</span> - <?php _e('With this plugin, you can import products to your group on ok.ru', 'import-from-yml'); ?>. <a href="https://wordpress.org/plugins/import-products-to-ok-ru/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">XML for Avito</span> - <?php _e('Сreates a XML-feed for importing your products to', 'import-from-yml'); ?> Avito. <a href="https://wordpress.org/plugins/xml-for-avito/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
					<p><span class="ipytw_bold">XML for O.Yandex (Яндекс Объявления)</span> - <?php _e('Сreates a XML-feed for importing your products to', 'import-from-yml'); ?> Яндекс.Объявления. <a href="https://wordpress.org/plugins/xml-for-o-yandex/" target="_blank"><?php _e('Read more', 'import-from-yml'); ?></a>.</p>
				</div>
			</div>
		</div><?php
	} // end get_html_my_plugins_list()

	public function admin_head_css_func() {
		/* печатаем css в шапке админки */
		print '<style>/* Import from YML */
			.metabox-holder .postbox-container .empty-container {height: auto !important;}
			.icp_img1 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl1.jpg);}
			.icp_img2 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl2.jpg);}
			.icp_img3 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl3.jpg);}
			.icp_img4 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl4.jpg);}
			.icp_img5 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl5.jpg);}
			.icp_img6 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl6.jpg);}
			.icp_img7 {background-image: url('. IPYTW_PLUGIN_DIR_URL .'img/sl7.jpg);}
		</style>';
	}

	private function init_hooks() {
		// наш класс, вероятно, вызывается во время срабатывания хука admin_menu.
		// admin_init - следующий в очереди срабатывания, хуки раньше admin_menu нет смысла вешать
		// add_action('admin_init', array($this, 'listen_submits'), 10);
		add_action('admin_print_footer_scripts', array($this, 'admin_head_css_func'));
	}

	private function get_feed_id() {
		return $this->feed_id;
	}

	private function save_plugin_set($opt_name, $feed_id, $save_if_empty = false) {
		if (isset($_POST[$opt_name])) {
			ipytw_optionUPD($opt_name, sanitize_text_field($_POST[$opt_name]), $feed_id, 'yes', 'set_arr');
		} else {
			if ($save_if_empty === true) {
				ipytw_optionUPD($opt_name, '0', $feed_id, 'yes', 'set_arr');
			}
		}
		return;
	}

	private function listen_submit() {
	// массовое удаление фидов по чекбоксу checkbox_yml_file
		if (isset($_GET['ipytw_form_id']) && ($_GET['ipytw_form_id'] === 'ipytw_wp_list_table')) {
			if (is_array($_GET['checkbox_yml_file']) && !empty($_GET['checkbox_yml_file'])) {
				if ($_GET['action'] === 'delete' || $_GET['action2'] === 'delete') {
					$checkbox_yml_file_arr = $_GET['checkbox_yml_file'];
					$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
					for ($i = 0; $i < count($checkbox_yml_file_arr); $i++) {
						$feed_id = $checkbox_yml_file_arr[$i];
						unset($ipytw_settings_arr[$feed_id]);
						wp_clear_scheduled_hook('ipytw_cron_period', array($feed_id)); // отключаем крон
						wp_clear_scheduled_hook('ipytw_cron_sborki', array($feed_id)); // отключаем крон
						$name_dir = IPYTW_SITE_UPLOADS_DIR_PATH.'/import-from-yml';
						$filename = $name_dir.'/feed-imported-offers-'.$i.'.tmp'; $res = unlink($filename);
						$filename = $name_dir.'/feed-importetd-cat-ids-'.$i.'.tmp'; $res = unlink($filename);
						ipytw_optionDEL('ipytw_status_sborki', $i);
						ipytw_optionDEL('ipytw_last_element', $i);
		
						$ipytw_registered_feeds_arr = ipytw_optionGET('ipytw_registered_feeds_arr');
						for ($n = 1; $n < count($ipytw_registered_feeds_arr); $n++) { // первый элемент не проверяем, тк. там инфо по последнему id
							if ($ipytw_registered_feeds_arr[$n]['id'] === $feed_id) {
								unset($ipytw_registered_feeds_arr[$n]);
								$ipytw_registered_feeds_arr = array_values($ipytw_registered_feeds_arr);
								ipytw_optionUPD('ipytw_registered_feeds_arr', $ipytw_registered_feeds_arr);
								break;
							}
						}
					}
					ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr);
/* ! */					$feed_id = get_first_feed_id();
				}

				if ($_GET['action'] === 'delete_all_imported_products' || $_GET['action2'] === 'delete_all_imported_products') {
					$checkbox_yml_file_arr = $_GET['checkbox_yml_file'];
					for ($i = 0; $i < count($checkbox_yml_file_arr); $i++) {
						$feed_id = $checkbox_yml_file_arr[$i];
						ipytw_delete_all_imported_products($feed_id);
					}
				}
			}
		}

		if (isset($_GET['feed_id'])) {
			if (isset($_GET['action'])) {
				$action = sanitize_text_field($_GET['action']);
				switch ($action) {
					case 'edit':
						$feed_id = sanitize_text_field($_GET['feed_id']);
						break;
					case 'delete':
						$feed_id = sanitize_text_field($_GET['feed_id']);
						$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
						unset($ipytw_settings_arr[$feed_id]);
						wp_clear_scheduled_hook('ipytw_cron_period', array($feed_id)); // отключаем крон
						wp_clear_scheduled_hook('ipytw_cron_sborki', array($feed_id)); // отключаем крон
						$name_dir = IPYTW_SITE_UPLOADS_DIR_PATH."/import-from-yml";
						$filename = $name_dir.'/feed-imported-offers-'.$feed_id.'.tmp'; if (file_exists($filename)) {unlink($filename);}
						$filename = $name_dir.'/feed-importetd-cat-ids-'.$feed_id.'.tmp'; if (file_exists($filename)) {unlink($filename);}
						ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr);
						ipytw_optionDEL('ipytw_status_sborki', $feed_id);
						ipytw_optionDEL('ipytw_last_element', $feed_id);
		
						$ipytw_registered_feeds_arr = ipytw_optionGET('ipytw_registered_feeds_arr');
						for ($n = 1; $n < count($ipytw_registered_feeds_arr); $n++) { // первый элемент не проверяем, тк. там инфо по последнему id
							if ($ipytw_registered_feeds_arr[$n]['id'] === $feed_id) {
								unset($ipytw_registered_feeds_arr[$n]);
								$ipytw_registered_feeds_arr = array_values($ipytw_registered_feeds_arr); 
								ipytw_optionUPD('ipytw_registered_feeds_arr', $ipytw_registered_feeds_arr);
								break;
							}
						}
		
						$feed_id = get_first_feed_id();
						break;
					default:
						$feed_id = get_first_feed_id();
				}
			} else {$feed_id = get_first_feed_id();}
		 } else {$feed_id = get_first_feed_id();}

		if (isset($_REQUEST['ipytw_submit_add_new_feed'])) { // если создаём новый фид
			if (!empty($_POST) && check_admin_referer('ipytw_nonce_action_add_new_feed', 'ipytw_nonce_field_add_new_feed')) {
				$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr');
				
				if (is_multisite()) {
					$ipytw_registered_feeds_arr = get_blog_option(get_current_blog_id(), 'ipytw_registered_feeds_arr');
					$feed_id = $ipytw_registered_feeds_arr[0]['last_id'];
					$feed_id++;
					$ipytw_registered_feeds_arr[0]['last_id'] = (string)$feed_id;
					$ipytw_registered_feeds_arr[] = array('id' => (string)$feed_id);
					update_blog_option(get_current_blog_id(), 'ipytw_registered_feeds_arr', $ipytw_registered_feeds_arr);
				} else {
					$ipytw_registered_feeds_arr = get_option('ipytw_registered_feeds_arr');
					$feed_id = $ipytw_registered_feeds_arr[0]['last_id'];
					$feed_id++;
					$ipytw_registered_feeds_arr[0]['last_id'] = (string)$feed_id;
					$ipytw_registered_feeds_arr[] = array('id' => (string)$feed_id);
					update_option('ipytw_registered_feeds_arr', $ipytw_registered_feeds_arr);
				}
				$name_dir = IPYTW_SITE_UPLOADS_DIR_PATH.'/import-from-yml/feed'.$feed_id;
				if (!is_dir($name_dir)) {
					if (!mkdir($name_dir)) {
						error_log('ERROR: Ошибка создания папки '.$name_dir.'; Файл: export.php; Строка: '.__LINE__, 0);
					}
				}

				$ipytw_data_arr_obj = new IPYTW_Data_Arr();
				$opts_arr = $ipytw_data_arr_obj->get_opts_name_and_def_date('all');
		
				$ipytw_settings_arr[$feed_id] = $opts_arr;
				ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr);
		
				ipytw_optionADD('ipytw_status_sborki', '-1', $feed_id);
				ipytw_optionADD('ipytw_last_element', '-1', $feed_id);
				print '<div class="updated notice notice-success is-dismissible"><p>'. __('Feed added', 'import-from-yml').'. ID = '.$feed_id.'.</p></div>';
			}
		}

		$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr'); 
		if (isset($_REQUEST['ipytw_submit_action'])) {
			if (!empty($_POST) && check_admin_referer('ipytw_nonce_action', 'ipytw_nonce_field')) {
				do_action('ipytw_prepend_submit_action', $feed_id);
				
				$feed_id = (int)sanitize_text_field($_POST['ipytw_num_feed_for_save']);

				$def_plugin_date_arr = new IPYTW_Data_Arr();
				$opts_name_and_def_date_arr = $def_plugin_date_arr->get_opts_name_and_def_date('public');
				foreach ($opts_name_and_def_date_arr as $key => $value) {
					$save_if_empty = false;
					$this->save_plugin_set($key, $feed_id, $save_if_empty);
				}

				$ipytw_settings_arr = ipytw_optionGET('ipytw_settings_arr'); 
				$ipytw_settings_arr[$feed_id]['ipytw_url_yml_file'] = sanitize_url($_POST['ipytw_url_yml_file']);	
				if (!empty($_FILES['ipytw_image_upload'])) {	
					if ($_FILES['ipytw_image_upload']['name'] !== '') {
						require_once(ABSPATH. 'wp-admin/includes/image.php');
						require_once(ABSPATH. 'wp-admin/includes/file.php');
						require_once(ABSPATH. 'wp-admin/includes/media.php');
			
						// Позволим WordPress перехватить загрузку. 
						// не забываем указать атрибут name поля input - 'ipytw_image_upload'
						$attachment_id = media_handle_upload('ipytw_image_upload', 0); // 0 - не прикреплятьк посту
			
						if (is_wp_error($attachment_id)) {
							printf('<div class="error notice notice-error is-dismissible"><p>YML %1$s %2$s! %3$s</p></div>', __('feed', 'import-from-yml'), __('upload error', 'import-from-yml'), $attachment_id->get_error_message());
						} else {
							$feed_url = wp_get_attachment_url($attachment_id);
							$ipytw_settings_arr[$feed_id]['ipytw_url_yml_file'] = $feed_url;
						}
					}
				}		
				$ipytw_settings_arr = apply_filters('ipytw_upd_settings_arr_filter', $ipytw_settings_arr, $feed_id);
				ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr);
			
				$arr_maybe = [ 'off', 'five_min', 'hourly', 'six_hours', 'twicedaily', 'daily', 'every_two_days', 'week' ];
				$ipytw_run_cron = sanitize_text_field($_POST['ipytw_run_cron']);
				if (in_array($ipytw_run_cron, $arr_maybe)) {		
					$ipytw_settings_arr[$feed_id]['ipytw_status_cron'] = $ipytw_run_cron;
					if ($ipytw_run_cron === 'off') {
						// отключаем крон
						wp_clear_scheduled_hook('ipytw_cron_period', array($feed_id));
						$ipytw_settings_arr[$feed_id]['ipytw_status_cron'] = 'off';
						
						wp_clear_scheduled_hook('ipytw_cron_sborki', array($feed_id));
						ipytw_optionUPD('ipytw_status_sborki', '-1', $feed_id);
						ipytw_optionUPD('ipytw_last_element', '-1', $feed_id);
						$ipytw_settings_arr[$feed_id]['ipytw_count_elements'] = -1;
					} else {
						ipytw_optionUPD('ipytw_status_sborki', '-1', $feed_id);
						ipytw_optionUPD('ipytw_last_element', '-1', $feed_id); // в теории тут можно регулировать "продолжить импорт" или "с нуля"
						$recurrence = $ipytw_run_cron;
						wp_clear_scheduled_hook('ipytw_cron_period', array($feed_id));
						wp_schedule_event(time(), $recurrence, 'ipytw_cron_period', array($feed_id));
						new IPYTW_Error_Log('FEED № '.$feed_id.'; ipytw_cron_period внесен в список заданий; Файл: export.php; Строка: '.__LINE__);
					}
					ipytw_optionUPD('ipytw_settings_arr', $ipytw_settings_arr);
				} else {
					new IPYTW_Error_Log('Крон '.$ipytw_run_cron.' не зарегистрирован. Файл: export.php; Строка: '.__LINE__);
				}
			}
		} 

		$this->feed_id = $feed_id;
		return;
	}
}